#define F_CPU 16000000UL
#define BAUDRATE       9600
#include <avr/io.h>
#include <util/delay.h>
#include "uart.h"
#include "SPIinit.h"

#define switchL   PD3
#define switchR   PD2

FILE mystdout = FDEV_SETUP_STREAM(uart_putc, NULL, _FDEV_SETUP_WRITE);

enum states { Off, Down, On, Up }; // Stavy tlatok
volatile enum states buttonL = Off;
volatile enum states buttonR = Off;


int main(void) {
	uart_init();
	stdout = &mystdout; // printf() funkcia je zapnut
    SPI_init(); // Inicializcia SPI
    MAX7219_init(); // Inicializcia MAX7219
	
    // Nastavenie tlaidiel ako vstupov a povolenie internch pull-up rezistorov
    DDRD &= ~((1 << switchL) | (1 << switchR));
    PORTD |= (1 << switchL) | (1 << switchR);
	
	clearDisp();
	smileAnimation();
	clearDisp();
	printf("Smer sipok sa da menit tlacitkami na nepajivom poli.\n");
    
    while (1) {
		if ( (buttonL == Off) &&  bit_is_clear(PIND, switchL)  )
	  {
		 delay(15);                 
		 if ( bit_is_clear(PIND, switchL) ) 
		 buttonL = Down;	            
	  }
	  else if ( (buttonL == Down) &&  bit_is_clear(PIND, switchL)  )
	  { 
  		 buttonL = On;
	  }
	  else if  ( (buttonL == On) &&  bit_is_clear(PIND, switchL) ) 	  
	  {  
		 buttonL = Up;
	  }
	  else if (  (buttonL == Up) &&  bit_is_clear(PIND, switchL) )
	  {
		 delay(15);                 
		 if ( bit_is_clear(PIND, switchL) ) 
		 buttonL = Off;
	  }
	  
	  
	  if ( (buttonR == Off) &&  bit_is_clear(PIND, switchR)  )
	  {
		 delay(15);                 
		 if ( bit_is_clear(PIND, switchR) ) 
		 buttonR = Down;	            
	  }
	  else if ( (buttonR == Down) &&  bit_is_clear(PIND, switchR)  )
	  { 
  		 buttonR = On;
	  }
	  else if  ( (buttonR == On) &&  bit_is_clear(PIND, switchR) ) 	  
	  {  
		 buttonR = Up;
	  }
	  else if (  (buttonR == Up) &&  bit_is_clear(PIND, switchR) )
	  {
		 delay(15);                 
		 if ( bit_is_clear(PIND, switchR) ) 
		 buttonR = Off;
	  }
	  
        if (buttonL == Down) {  
			printf("Smer sipok: <--\r");
			vlavo(); 
			buttonL = Up; // Nastav stav tlaidlo L na Up po animcii
		}
        if (buttonR == Down) {
			printf("Smer sipok: -->\r");  
			vpravo(); 
			buttonR = Up; // Nastav stav tlaidlo R na Up po animcii
		}
    }
}
